// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Mller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <vector>

#include "LinesSolver.h"

class CeresSearch :
    public LinesSolver
{
public:
    std::string getPuzzleName() const override;
    std::string getInputFileName() const override;
    void finish() override;
private:
    char xmas[4] = { 'X', 'M', 'A', 'S' };
    void computeXmasCount(const Point2& start);
    void computeX_MasCount(const Point2& start);
};
