// Solutions to the Advent Of Code 2024.
// Copyright (C) 2024  Stefan Mller
//
// This program is free software: you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free Software
// Foundation, either version 3 of the License, or (at your option) any later
// version.
//
// This program is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License along with
// this program.  If not, see <http://www.gnu.org/licenses/>.

#pragma once

#include <string>

class Solver
{
public:
    Solver();
    virtual ~Solver() {};
    virtual std::string getPuzzleName() const = 0;
    virtual std::string getInputFileName() const = 0;
    virtual void processDataLine(const std::string& line) = 0;
    virtual void finish() = 0;
    long long int getResultPart1() const;
    long long int getResultPart2() const;
protected:
    long long int part1;
    long long int part2;
};
